diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-core.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-core.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-core.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-core.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,24 @@
+#ifndef _LTT_FACILITY_ID_CORE_H_
+#define _LTT_FACILITY_ID_CORE_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_core_F1C514F;
+extern ltt_facility_t ltt_facility_core;
+
+
+/****  event index  ****/
+
+enum core_event {
+	event_core_facility_load,
+	event_core_facility_unload,
+	event_core_time_heartbeat,
+	event_core_state_dump_facility_load,
+	facility_core_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_CORE_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-fs.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-fs.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-fs.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-fs.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,31 @@
+#ifndef _LTT_FACILITY_ID_FS_H_
+#define _LTT_FACILITY_ID_FS_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_fs_40A645EC;
+extern ltt_facility_t ltt_facility_fs;
+
+
+/****  event index  ****/
+
+enum fs_event {
+	event_fs_buf_wait_start,
+	event_fs_buf_wait_end,
+	event_fs_exec,
+	event_fs_open,
+	event_fs_close,
+	event_fs_read,
+	event_fs_write,
+	event_fs_seek,
+	event_fs_ioctl,
+	event_fs_select,
+	event_fs_poll,
+	facility_fs_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_FS_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-ipc.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-ipc.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-ipc.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-ipc.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,24 @@
+#ifndef _LTT_FACILITY_ID_IPC_H_
+#define _LTT_FACILITY_ID_IPC_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_ipc_14120A9A;
+extern ltt_facility_t ltt_facility_ipc;
+
+
+/****  event index  ****/
+
+enum ipc_event {
+	event_ipc_call,
+	event_ipc_msg_create,
+	event_ipc_sem_create,
+	event_ipc_shm_create,
+	facility_ipc_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_IPC_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-kernel.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-kernel.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-kernel.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-kernel.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,30 @@
+#ifndef _LTT_FACILITY_ID_KERNEL_H_
+#define _LTT_FACILITY_ID_KERNEL_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_kernel_E78275BF;
+extern ltt_facility_t ltt_facility_kernel;
+
+
+/****  event index  ****/
+
+enum kernel_event {
+	event_kernel_syscall_entry,
+	event_kernel_syscall_exit,
+	event_kernel_trap_entry,
+	event_kernel_trap_exit,
+	event_kernel_soft_irq_entry,
+	event_kernel_soft_irq_exit,
+	event_kernel_tasklet_entry,
+	event_kernel_tasklet_exit,
+	event_kernel_irq_entry,
+	event_kernel_irq_exit,
+	facility_kernel_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_KERNEL_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-memory.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-memory.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-memory.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-memory.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,26 @@
+#ifndef _LTT_FACILITY_ID_MEMORY_H_
+#define _LTT_FACILITY_ID_MEMORY_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_memory_D63D41C7;
+extern ltt_facility_t ltt_facility_memory;
+
+
+/****  event index  ****/
+
+enum memory_event {
+	event_memory_page_alloc,
+	event_memory_page_free,
+	event_memory_swap_in,
+	event_memory_swap_out,
+	event_memory_page_wait_start,
+	event_memory_page_wait_end,
+	facility_memory_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_MEMORY_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-network.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-network.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-network.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-network.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,22 @@
+#ifndef _LTT_FACILITY_ID_NETWORK_H_
+#define _LTT_FACILITY_ID_NETWORK_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_network_8B91EC6C;
+extern ltt_facility_t ltt_facility_network;
+
+
+/****  event index  ****/
+
+enum network_event {
+	event_network_packet_in,
+	event_network_packet_out,
+	facility_network_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_NETWORK_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-process.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-process.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-process.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-process.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,29 @@
+#ifndef _LTT_FACILITY_ID_PROCESS_H_
+#define _LTT_FACILITY_ID_PROCESS_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_process_F7697017;
+extern ltt_facility_t ltt_facility_process;
+
+
+/****  event index  ****/
+
+enum process_event {
+	event_process_fork,
+	event_process_kernel_thread,
+	event_process_exit,
+	event_process_wait,
+	event_process_free,
+	event_process_kill,
+	event_process_signal,
+	event_process_wakeup,
+	event_process_schedchange,
+	facility_process_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_PROCESS_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-socket.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-socket.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-socket.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-socket.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,24 @@
+#ifndef _LTT_FACILITY_ID_SOCKET_H_
+#define _LTT_FACILITY_ID_SOCKET_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_socket_5E76ED18;
+extern ltt_facility_t ltt_facility_socket;
+
+
+/****  event index  ****/
+
+enum socket_event {
+	event_socket_call,
+	event_socket_create,
+	event_socket_sendmsg,
+	event_socket_recvmsg,
+	facility_socket_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_SOCKET_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-statedump.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-statedump.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-statedump.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-statedump.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,25 @@
+#ifndef _LTT_FACILITY_ID_STATEDUMP_H_
+#define _LTT_FACILITY_ID_STATEDUMP_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_statedump_31582B7A;
+extern ltt_facility_t ltt_facility_statedump;
+
+
+/****  event index  ****/
+
+enum statedump_event {
+	event_statedump_enumerate_file_descriptors,
+	event_statedump_enumerate_vm_maps,
+	event_statedump_enumerate_modules,
+	event_statedump_enumerate_interrupts,
+	event_statedump_statedump_end,
+	facility_statedump_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_STATEDUMP_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-id-timer.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-timer.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-id-timer.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-id-timer.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,23 @@
+#ifndef _LTT_FACILITY_ID_TIMER_H_
+#define _LTT_FACILITY_ID_TIMER_H_
+
+#ifdef CONFIG_LTT
+#include <linux/ltt-facilities.h>
+
+/****  facility handle  ****/
+
+extern ltt_facility_t ltt_facility_timer_5EACEACA;
+extern ltt_facility_t ltt_facility_timer;
+
+
+/****  event index  ****/
+
+enum timer_event {
+	event_timer_expired,
+	event_timer_softirq,
+	event_timer_set_itimer,
+	facility_timer_num_events
+};
+
+#endif //CONFIG_LTT
+#endif //_LTT_FACILITY_ID_TIMER_H_
diff -uNrp linux-2.6.14.5/include/linux/ltt/ltt-facility-ipc.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-ipc.h
--- linux-2.6.14.5/include/linux/ltt/ltt-facility-ipc.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/include/linux/ltt/ltt-facility-ipc.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,530 @@
+#ifndef _LTT_FACILITY_IPC_H_
+#define _LTT_FACILITY_IPC_H_
+
+#include <linux/types.h>
+#include <linux/ltt/ltt-facility-id-ipc.h>
+#include <linux/ltt-core.h>
+
+/* Named types */
+
+/* Event call structures */
+
+/* Event call logging function */
+static inline void trace_ipc_call(
+		unsigned int lttng_param_call_number,
+		int lttng_param_first)
+#if (!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+{
+}
+#else
+{
+	unsigned int index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace;
+	struct rchan_buf *relayfs_buf;
+	void *buffer = NULL;
+	size_t real_to_base = 0; /* The buffer is allocated on arch_size alignment */
+	size_t *to_base = &real_to_base;
+	size_t real_to = 0;
+	size_t *to = &real_to;
+	size_t real_len = 0;
+	size_t *len = &real_len;
+	size_t reserve_size;
+	size_t slot_size;
+	size_t align;
+	const void *real_from;
+	const void **from = &real_from;
+	cycles_t tsc;
+	size_t before_hdr_pad, after_hdr_pad, header_size;
+
+	if(ltt_traces.num_active_traces == 0) return;
+
+	/* For each field, calculate the field size. */
+	/* size = *to_base + *to + *len */
+	/* Assume that the padding for alignment starts at a
+	 * sizeof(void *) address. */
+
+	*from = &lttng_param_call_number;
+	align = sizeof(unsigned int);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(unsigned int);
+
+	*from = &lttng_param_first;
+	align = sizeof(int);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(int);
+
+	reserve_size = *to_base + *to + *len;
+	preempt_disable();
+	ltt_nesting[smp_processor_id()]++;
+	index = ltt_get_index_from_facility(ltt_facility_ipc_14120A9A,
+						event_ipc_call);
+
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if(!trace->active) continue;
+
+		channel = ltt_get_channel_from_index(trace, index);
+		relayfs_buf = channel->rchan->buf[smp_processor_id()];
+
+		slot_size = 0;
+		buffer = ltt_reserve_slot(trace, relayfs_buf,
+			reserve_size, &slot_size, &tsc,
+			&before_hdr_pad, &after_hdr_pad, &header_size);
+		if(!buffer) continue; /* buffer full */
+
+		*to_base = *to = *len = 0;
+
+		ltt_write_event_header(trace, channel, buffer,
+			ltt_facility_ipc_14120A9A, event_ipc_call,
+			reserve_size, before_hdr_pad, tsc);
+		*to_base += before_hdr_pad + after_hdr_pad + header_size;
+
+		*from = &lttng_param_call_number;
+		align = sizeof(unsigned int);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(unsigned int);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		*from = &lttng_param_first;
+		align = sizeof(int);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(int);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		ltt_commit_slot(relayfs_buf, buffer, slot_size);
+
+	}
+
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable_no_resched();
+}
+#endif //(!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+
+
+/* Event msg_create structures */
+
+/* Event msg_create logging function */
+static inline void trace_ipc_msg_create(
+		long lttng_param_id,
+		int lttng_param_flags)
+#if (!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+{
+}
+#else
+{
+	unsigned int index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace;
+	struct rchan_buf *relayfs_buf;
+	void *buffer = NULL;
+	size_t real_to_base = 0; /* The buffer is allocated on arch_size alignment */
+	size_t *to_base = &real_to_base;
+	size_t real_to = 0;
+	size_t *to = &real_to;
+	size_t real_len = 0;
+	size_t *len = &real_len;
+	size_t reserve_size;
+	size_t slot_size;
+	size_t align;
+	const void *real_from;
+	const void **from = &real_from;
+	cycles_t tsc;
+	size_t before_hdr_pad, after_hdr_pad, header_size;
+
+	if(ltt_traces.num_active_traces == 0) return;
+
+	/* For each field, calculate the field size. */
+	/* size = *to_base + *to + *len */
+	/* Assume that the padding for alignment starts at a
+	 * sizeof(void *) address. */
+
+	*from = &lttng_param_id;
+	align = sizeof(long);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(long);
+
+	*from = &lttng_param_flags;
+	align = sizeof(int);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(int);
+
+	reserve_size = *to_base + *to + *len;
+	preempt_disable();
+	ltt_nesting[smp_processor_id()]++;
+	index = ltt_get_index_from_facility(ltt_facility_ipc_14120A9A,
+						event_ipc_msg_create);
+
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if(!trace->active) continue;
+
+		channel = ltt_get_channel_from_index(trace, index);
+		relayfs_buf = channel->rchan->buf[smp_processor_id()];
+
+		slot_size = 0;
+		buffer = ltt_reserve_slot(trace, relayfs_buf,
+			reserve_size, &slot_size, &tsc,
+			&before_hdr_pad, &after_hdr_pad, &header_size);
+		if(!buffer) continue; /* buffer full */
+
+		*to_base = *to = *len = 0;
+
+		ltt_write_event_header(trace, channel, buffer,
+			ltt_facility_ipc_14120A9A, event_ipc_msg_create,
+			reserve_size, before_hdr_pad, tsc);
+		*to_base += before_hdr_pad + after_hdr_pad + header_size;
+
+		*from = &lttng_param_id;
+		align = sizeof(long);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(long);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		*from = &lttng_param_flags;
+		align = sizeof(int);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(int);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		ltt_commit_slot(relayfs_buf, buffer, slot_size);
+
+	}
+
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable_no_resched();
+}
+#endif //(!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+
+
+/* Event sem_create structures */
+
+/* Event sem_create logging function */
+static inline void trace_ipc_sem_create(
+		long lttng_param_id,
+		int lttng_param_flags)
+#if (!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+{
+}
+#else
+{
+	unsigned int index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace;
+	struct rchan_buf *relayfs_buf;
+	void *buffer = NULL;
+	size_t real_to_base = 0; /* The buffer is allocated on arch_size alignment */
+	size_t *to_base = &real_to_base;
+	size_t real_to = 0;
+	size_t *to = &real_to;
+	size_t real_len = 0;
+	size_t *len = &real_len;
+	size_t reserve_size;
+	size_t slot_size;
+	size_t align;
+	const void *real_from;
+	const void **from = &real_from;
+	cycles_t tsc;
+	size_t before_hdr_pad, after_hdr_pad, header_size;
+
+	if(ltt_traces.num_active_traces == 0) return;
+
+	/* For each field, calculate the field size. */
+	/* size = *to_base + *to + *len */
+	/* Assume that the padding for alignment starts at a
+	 * sizeof(void *) address. */
+
+	*from = &lttng_param_id;
+	align = sizeof(long);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(long);
+
+	*from = &lttng_param_flags;
+	align = sizeof(int);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(int);
+
+	reserve_size = *to_base + *to + *len;
+	preempt_disable();
+	ltt_nesting[smp_processor_id()]++;
+	index = ltt_get_index_from_facility(ltt_facility_ipc_14120A9A,
+						event_ipc_sem_create);
+
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if(!trace->active) continue;
+
+		channel = ltt_get_channel_from_index(trace, index);
+		relayfs_buf = channel->rchan->buf[smp_processor_id()];
+
+		slot_size = 0;
+		buffer = ltt_reserve_slot(trace, relayfs_buf,
+			reserve_size, &slot_size, &tsc,
+			&before_hdr_pad, &after_hdr_pad, &header_size);
+		if(!buffer) continue; /* buffer full */
+
+		*to_base = *to = *len = 0;
+
+		ltt_write_event_header(trace, channel, buffer,
+			ltt_facility_ipc_14120A9A, event_ipc_sem_create,
+			reserve_size, before_hdr_pad, tsc);
+		*to_base += before_hdr_pad + after_hdr_pad + header_size;
+
+		*from = &lttng_param_id;
+		align = sizeof(long);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(long);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		*from = &lttng_param_flags;
+		align = sizeof(int);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(int);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		ltt_commit_slot(relayfs_buf, buffer, slot_size);
+
+	}
+
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable_no_resched();
+}
+#endif //(!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+
+
+/* Event shm_create structures */
+
+/* Event shm_create logging function */
+static inline void trace_ipc_shm_create(
+		long lttng_param_id,
+		int lttng_param_flags)
+#if (!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+{
+}
+#else
+{
+	unsigned int index;
+	struct ltt_channel_struct *channel;
+	struct ltt_trace_struct *trace;
+	struct rchan_buf *relayfs_buf;
+	void *buffer = NULL;
+	size_t real_to_base = 0; /* The buffer is allocated on arch_size alignment */
+	size_t *to_base = &real_to_base;
+	size_t real_to = 0;
+	size_t *to = &real_to;
+	size_t real_len = 0;
+	size_t *len = &real_len;
+	size_t reserve_size;
+	size_t slot_size;
+	size_t align;
+	const void *real_from;
+	const void **from = &real_from;
+	cycles_t tsc;
+	size_t before_hdr_pad, after_hdr_pad, header_size;
+
+	if(ltt_traces.num_active_traces == 0) return;
+
+	/* For each field, calculate the field size. */
+	/* size = *to_base + *to + *len */
+	/* Assume that the padding for alignment starts at a
+	 * sizeof(void *) address. */
+
+	*from = &lttng_param_id;
+	align = sizeof(long);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(long);
+
+	*from = &lttng_param_flags;
+	align = sizeof(int);
+
+	if(*len == 0) {
+		*to += ltt_align(*to, align); /* align output */
+	} else {
+		*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+	}
+
+	*len += sizeof(int);
+
+	reserve_size = *to_base + *to + *len;
+	preempt_disable();
+	ltt_nesting[smp_processor_id()]++;
+	index = ltt_get_index_from_facility(ltt_facility_ipc_14120A9A,
+						event_ipc_shm_create);
+
+	list_for_each_entry_rcu(trace, &ltt_traces.head, list) {
+		if(!trace->active) continue;
+
+		channel = ltt_get_channel_from_index(trace, index);
+		relayfs_buf = channel->rchan->buf[smp_processor_id()];
+
+		slot_size = 0;
+		buffer = ltt_reserve_slot(trace, relayfs_buf,
+			reserve_size, &slot_size, &tsc,
+			&before_hdr_pad, &after_hdr_pad, &header_size);
+		if(!buffer) continue; /* buffer full */
+
+		*to_base = *to = *len = 0;
+
+		ltt_write_event_header(trace, channel, buffer,
+			ltt_facility_ipc_14120A9A, event_ipc_shm_create,
+			reserve_size, before_hdr_pad, tsc);
+		*to_base += before_hdr_pad + after_hdr_pad + header_size;
+
+		*from = &lttng_param_id;
+		align = sizeof(long);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(long);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		*from = &lttng_param_flags;
+		align = sizeof(int);
+
+		if(*len == 0) {
+			*to += ltt_align(*to, align); /* align output */
+		} else {
+			*len += ltt_align(*to+*len, align); /* alignment, ok to do a memcpy of it */
+		}
+
+		*len += sizeof(int);
+
+		/* Flush pending memcpy */
+		if(*len != 0) {
+			memcpy(buffer+*to_base+*to, *from, *len);
+			*to += *len;
+			*len = 0;
+		}
+
+		ltt_commit_slot(relayfs_buf, buffer, slot_size);
+
+	}
+
+	ltt_nesting[smp_processor_id()]--;
+	preempt_enable_no_resched();
+}
+#endif //(!defined(CONFIG_LTT) || !defined(CONFIG_LTT_FACILITY_IPC))
+
+
+#endif //_LTT_FACILITY_IPC_H_
